//////////////////////////////////////////////////////////////
//
// 25/03/2009   JLGT  Versin 1.0
//Este componente es Freeware y se puede modificar y alterar
//Siempre y cuando se distribuya libremente las modificaciones
//Se que se puede acortar el cdigo, pero prefiero
//dejarlo de esta manera para poder comprenderlo mejor
//Este componente es uno que parte de una idea que tube hace tiempo
// Sobre un codigo que hacia esto mismo, lo que he tratado de mejorarlo y
// aprender nuevas tecnicas.
///////////////////////////////////////////////////////////////////////////
//
//        IMPORTANTE
//
/////////////////////////////////////////////////////////////////////////////
// La variable ShadowBasicGhange impide que si no hay cambios en el componente se este repintando
//una y otra vez, estropeando el proceso y  haciendo efectos no deseados
//
// Esto es meramente un componente visual, al que es posible
// hacerle muchas mejoras, se que cualquier programa puede funcionar sin el
// pero pensar que estoy usando un metodo de estudio un tanto particular
// As que si os gusta me alegro y si no, pues nada no lo useis.
// El procedimiento refresh es que no sabia como solucionar al minimizar y mazimzar el form, asi
// que hago una llamada ala propiedad procedimiento
// El refres es para aadirselo en el form que usemos el componente en el
// evento onResize, ya que no encontre una forma de que lo controlare el componente
// Sin hacer un parapadeo desagradable, al estar ejecutandose el evento OnPaint
// de manera fija. si encontrais la manera, por favor mandarme una modificacin de este codigo
///////////////////////////////////////////////////////////

unit Shadowbasic;

interface

uses   Classes, Messages, Windows, Controls, Stdctrls, Graphics, ExtCtrls, Forms, DBCtrls, Dialogs;

type  //Creamos los Tipos Necesarios
  TShadowDir = (SLeftTop,SLeftBotton,SRightTop,SRightBotton);   //Direcciones posibles de la siombra
  TShadowSize= 0..19;                                            //Tamaos posibles de la sombra
  TSizeSmoothedDegraded= 0..255;                                //Valores posibles del degradado
  TShadowbasic = class(TComponent)
  private
    FS_Other : Boolean;   //Para  el resto de componentes
    FS_Panel : Boolean;   //Para Paneles
    FS_Label : Boolean;   //Para Labels
    FS_Edit : Boolean;    //Para Edit
    FSmoothed:Boolean;    //Suavizado
    FS_Border: Boolean;   //Pintar un borde
    FS_BorderColor: Tcolor; //Color del Borde
    FSizeSD: TSizeSmoothedDegraded;  //Posibles valores del suavizado con degradado
    OwnerOnPaint: TNotifyEvent;      //Evento del Paint Copiado otro Comp
    FVisible:Boolean;       //Visible la sombra
    FShadowColor: TColor;   //Color de la sombra
    FDireccion: TShadowDir; //Direccin de la sombra
    FSize: TShadowSize;     //Tamao de la sombra
    procedure SetShadowColor (const Value: TColor);
    procedure SetVisible (const Value: Boolean);
    procedure SetDireccion (const Value: TShadowDir);
    procedure SetSize (const Value: TShadowSize);
    procedure SetS_Other (const Value: Boolean);
    procedure SetS_Panel (const Value: Boolean);
    procedure SetS_Label(const Value: Boolean);
    procedure SetS_Edit (const Value: Boolean);
    procedure SetSmoothed (const Value: Boolean);
    procedure SetS_Border (const Value: Boolean);
    procedure SetSizeSD (const Value: TSizeSmoothedDegraded);
    procedure SetS_BorderColor (const Value: TColor);
    { Private declarations }
  protected
    { Protected declarations }
    procedure MyOnPaint(Sender: TObject);   //Copiado de otro Comp
    
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy(); override;
    procedure Refresh;
  published
    { Published declarations }
    property S_Other: Boolean read FS_Other write SetS_Other default True;
    property S_Panel: Boolean read FS_Panel write SetS_Panel default True;
    property S_Label: Boolean read FS_Label write SetS_Label default False;
    property S_Edit : Boolean read FS_Edit  write SetS_Edit default True;
    property Visible: Boolean read FVisible write SetVisible default false;
    property ShadowColor: TColor read FShadowColor write SetShadowColor default clBlack;
    property Direccion: TShadowDir read FDireccion write SetDireccion default SLeftTop;
    property Size: TShadowSize read FSize write SetSize default 1;
    property Smoothed: Boolean read FSmoothed write SetSmoothed default false;
    property SizeSD: TSizeSmoothedDegraded read FSizeSD write SetSizeSD default 1;
    property S_BorderColor: TColor read FS_BorderColor write SetS_BorderColor default clBlack;
    property S_Border: Boolean read FS_Border write SetS_Border default false;
  end;

procedure Register;
var ShadowBasicGhange,Frestore,Factivo: Boolean; //Para controlar si cambiamos alguna propiedad en elcomponente

implementation

procedure Register;
begin
  RegisterComponents('Samples', [Tshadowbasic]);
end;
constructor TShadowbasic.Create(AOwner: TComponent);
begin
  inherited;
//  FPropertyShadow:=TPropertyShadow.Create;   //Para crear propiedades agrupadas   6/
  ShadowColor:=clBlack;
  Size:=1;
  S_Other:=True;
  S_Panel:=True;
  S_Label:=True;
  S_Panel:=True;
  S_Edit:=True;
  Visible:=False;
  Direccion:=SLeftTop;
  SizeSD:=1;
  Smoothed:=False;
  S_Border:=False;
  S_BorderColor:=clBlack;
  Frestore:=False;
  Factivo:=False;
  with Owner as TForm do  //Iniciio ciopiado otro comp para el paint
  begin
     OwnerOnPaint := OnPaint;
     OnPaint := MyOnPaint;
  end;                  //fin ciopiado otro comp para el paint
  ShadowBasicGhange:=False;
end;
destructor TShadowbasic.Destroy();
begin
 // FPropertyShadow.Free;  //Para crear propiedades agrupadas   7/
   inherited Destroy;
end;

procedure TShadowbasic.SetS_Other(const Value: Boolean);
begin
     if (FS_Other <> value) then FS_Other:= value;
     ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetS_Panel(const Value: Boolean);
begin
     if (FS_Panel <> value) then FS_Panel:= value;
     ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetS_Label(const Value: Boolean);
begin
     if (FS_Label <> value) then FS_Label:= value;
     ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetS_Edit(const Value: Boolean);
begin
    if (FS_Edit <> value) then FS_Edit:= value;
    ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetShadowColor(const Value: TColor);
begin
    if (FShadowColor <> value) then FShadowColor:= value;
    ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetVisible(const Value: Boolean);
begin
    if (FVisible <> value) then FVisible:= value;
    ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetDireccion(const Value: TShadowDir);
begin
    if (FDireccion <> value) then FDireccion:= value;
    ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetSize(const Value: TShadowSize);
begin
   if (FSize <> value) then FSize:= value;
   ShadowBasicGhange:=True;
end;

procedure TShadowbasic.SetSmoothed(const Value: Boolean);
begin
     if (FSmoothed <> value) then FSmoothed:= value;
      ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetSizeSD(const Value: TSizeSmoothedDegraded);
begin
     if (FSizeSD <> value) then FSizeSD:= value;
     ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetS_Border(const Value: Boolean);
begin
     if (FS_border <> value) then FS_Border:= value;
     ShadowBasicGhange:=True;
end;
procedure TShadowbasic.SetS_BorderColor(const Value: TColor);
begin
     if (FS_BorderColor <> value) then FS_BorderColor:= value;
     ShadowBasicGhange:=True;
end;
Procedure TShadowbasic.Refresh;
begin
    Frestore:=True;
end;

procedure TShadowbasic.MyOnPaint(Sender: TObject);
var I,I2,Vtop,Vleft,Vright,VBotton,VWidth,Vheith,CRojo,CVerde,CAzul,VSize:Integer;
    Painter,SUBAVT,SUBAVL: Boolean;
    Xrect2,Xrect3: TRect;         //Unit Windows
    OLd:TColor;
begin
  with Owner as Tform do   //Inicio copiado otro comp para el paint Capturamos el mensage del Paint
  begin
    OnPaint := OwnerOnPaint;
    If Assigned(OnPaint) then OwnerOnPaint(sender);
    Application.ProcessMessages;  //Capturamos si hay un mensaje  del paint
    OwnerOnPaint := OnPaint;
    OnPaint := MyOnPaint;
  end;            //Fin copiado otro comp para el paint
  if ((TForm(Owner).Active=True) and (Factivo=True)) then
  begin  //Al devolverlo al frente
        Frestore:=true;
        Factivo:=false;
  end;
  if ((TForm(Owner).Active=False)) then Factivo:=true;   //Si lo tapamos con otra ventana
  if Frestore=true then
  begin
      ShadowBasicGhange:=True;
      Frestore:=False;
      TForm(Owner).Refresh;
  end;
  if FS_Border=true then VSize:=FSize+1      //Si el border esta activo  aumentamos en uno el tamao de la sombra
                    else VSize:=FSize;
  I:=0;
  if ((FVisible=true) and (ShadowBasicGhange=True) )then        //si tenemos que dibujar la sombra y hay cambios en el componente
  begin
     ShadowBasicGhange:=False;
    old := TForm(Owner).canvas.brush.color; //Guadamos el color del Form
    for I := 0 to TForm(Owner).ControlCount - 1 do //Comprobamos cuantos Controles Tenemos en el Fom
    begin
      Painter:=True;  //Dibujamos la sombra
      /////////////////////////////Diferenciamos Clases de los componentes////////////////////////////////////////////
      if (TForm(Owner).Controls[i].ClassType)=TPanel then  //Miramos si el componente es un panel
      begin
         if FS_Panel=true then Painter:=True //Comprobamoos si pintamos los Paneles
                          else Painter:=false;
      end;
      /////////////////////////////Diferenciamos Clases de los componentes////////////////////////////////////////////
      if (TForm(Owner).Controls[i].ClassType)=TLabel   then  //Miramos si el componente es un Labell
      begin
         if FS_Label=true then Painter:=True //Comprobamoos si pintamos los LAbel
                          else Painter:=false;
        // TForm(Owner).Controls[i].Visible:=False;
        // TForm(Owner).Controls[i].Visible:=True;
      end;
      /////////////////////////////Diferenciamos Clases de los componentes////////////////////////////////////////////
      if ((TForm(Owner).Controls[i].ClassType)=TEdit)or
         ((TForm(Owner).Controls[i].ClassType)=TDBEdit)or
         ((TForm(Owner).Controls[i].ClassType)=TLabeledEdit)  then//Miramos si el componente es un Edit o variante
      begin
         if FS_Edit=true then Painter:=True //Comprobamoos si pintamos los edit
                         else Painter:=false;
      end;
      /////////////////////////////Diferenciamos Clases de los componentes////////////////////////////////////////////
      if ((TForm(Owner).Controls[i].ClassType)<>TEdit)and
         ((TForm(Owner).Controls[i].ClassType)<>TDBEdit)and
         ((TForm(Owner).Controls[i].ClassType)<>TLabeledEdit)and
         ((TForm(Owner).Controls[i].ClassType)<>TPanel)and
         ((TForm(Owner).Controls[i].ClassType)<>TLabel) then  //Miramos si el componente es otro diferente
      begin
         if FS_Other=true then Painter:=True //Comprobamoos si pintamos los otros componentest
                          else Painter:=false;
      end;
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      TForm(Owner).canvas.brush.Color := FShadowColor; //Asinamos el color de la sombra
      CRojo:=GetRValue(ColorToRGB(FShadowColor));  //Valor Inicial Rojo
      CVerde:=GetGValue(ColorToRGB(FShadowColor)); //Valor Inicial Verde
      CAzul:=GetBValue(ColorToRGB(FShadowColor));  //Valor Inicial Azul
      Xrect2:= TForm(Owner).Controls[i].BoundsRect; //Valores del Rect del componente
      if FDireccion=SLeftTop then    //Si es arriba izq
      begin
        Vtop:=Xrect2.top-VSize;
        Vleft:=Xrect2.Left-VSize;
        Vright:=Xrect2.Right-VSize;
        VBotton:=Xrect2.Bottom-VSize;
        SUBAVT:=False;              // Asiganamos si el Top Es Positivo (true) o Negativo (False)
        SUBAVL:=False;              // Asiganamos si el Left Positivo (true) o Negativo
      end;
      if FDireccion=SRightTop then    //Si es arriba Dcha
      begin
        Vtop:=Xrect2.top-VSize;
        Vleft:=Xrect2.Left+VSize;
        Vright:=Xrect2.Right+VSize;
        VBotton:=Xrect2.Bottom-VSize;
        SUBAVT:=False;
        SUBAVL:=True;
      end;
      if FDireccion=SLeftBotton then    //Si es abajo izq
      begin
        Vtop:=Xrect2.top+VSize;
        Vleft:=Xrect2.Left-Size;
        Vright:=Xrect2.Right-VSize;
        VBotton:=Xrect2.Bottom+VSize;
        SUBAVT:=True;
        SUBAVL:=False;
      end;
      if FDireccion=SRightBotton then    //Si es arriba Dcha
      begin
        Vtop:=Xrect2.top+VSize;
        Vleft:=Xrect2.Left+VSize;
        Vright:=Xrect2.Right+VSize;
        VBotton:=Xrect2.Bottom+VSize;
        SUBAVT:=True;
        SUBAVL:=True;
      end;
      For I2 := 2 to (FSize+1)  do        //Asignamos el pintado de la sombra
      begin
        if SUBAVL = true then
        begin
          Xrect2.Left := Vleft-I2;
          Xrect2.Right:=Vright-I2;
        end Else
        begin
          Xrect2.Left := Vleft+I2;
          Xrect2.Right:=Vright+I2;
        end;
        if SUBAVT = true then
        begin
          Xrect2.Top := Vtop-I2;
          Xrect2.Bottom:=VBotton-I2;
        end Else
        begin
           Xrect2.Top := Vtop+I2;
           Xrect2.Bottom:=VBotton+I2;
        end;
        if Painter=true then //Si el componente asignado esta en nuestra lista de activos
        begin
            TForm(Owner).canvas.brush.Color :=RGB(CRojo,CVerde,CAzul);
            TForm(Owner).Canvas.fillrect(Xrect2);
            if FSmoothed=true then  //Si esta activo el suavizado/Degradado
            begin
              //Restamos el valor de SizeSD a cada color
              CRojo:=CRojo-FSizeSD;
              CVerde:=CVerde-FSizeSD;
              CAzul:=CAzul-FSizeSD;
              //Si el valor es iugal o inferior a 0 lo ponemos a 0
              if CRojo<=0 then CRojo:=0;
              if CVerde<=0 then CVerde:=0;
              if CAzul<=0 then CAzul:=0;
            end;
        end;
      end; //Fin fel For I2
      if (FS_Border=true) and (FVisible=True) then    //SI esta habilitado para verlo y el border esta activo
      begin
            Xrect3:= TForm(Owner).Controls[i].BoundsRect; //Valores del Rect del componente
            Xrect3.Left:=Xrect3.Left-1;
            Xrect3.Top:=Xrect3.Top-1;
            Xrect3.Right:=Xrect3.Right+1;
            Xrect3.Bottom:=Xrect3.Bottom+1;
            TForm(Owner).Canvas.Brush.color:=FS_BorderColor;
            //Dibujamos un contorno sobre el Control agrandandolo en 1 por todos los lados
            TForm(Owner).Canvas.fillrect(Xrect3);
      end;
      Xrect3:= TForm(Owner).Controls[i].BoundsRect;
      TForm(Owner).Canvas.Brush.color:=old;
      TForm(Owner).Canvas.fillrect(Xrect3);
      // dibujamos el recuadro del control del color del form  y devolvemos el color a la brocha del Form
    end; //Fin del For I
    Painter:=False;
  end;
end;

end.

