unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Shadowbasic, StdCtrls, ExtCtrls, Spin, Buttons, Grids, ComCtrls,
  Mask, DBCtrls, jpeg;

type
  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    ColorBox1: TColorBox;
    ComboBox1: TComboBox;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    BitBtn1: TBitBtn;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    StringGrid1: TStringGrid;
    MonthCalendar1: TMonthCalendar;
    ProgressBar1: TProgressBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel1: TPanel;
    Edit1: TEdit;
    DBEdit1: TDBEdit;
    Shadowbasic1: TShadowbasic;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    LabeledEdit1: TLabeledEdit;
    Label6: TLabel;
    ColorBox2: TColorBox;
    CheckBox7: TCheckBox;
    Image1: TImage;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    RadioButton1: TRadioButton;
    Memo1: TMemo;
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ColorBox2Change(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure FormResize(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  xa:Integer;
implementation

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked=true then Shadowbasic1.Visible:=True
                            else Shadowbasic1.Visible:=False;
  Repaint;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
      if CheckBox2.Checked=true then Shadowbasic1.Smoothed:=True
                                else Shadowbasic1.Smoothed:=False;
  Repaint;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked=true then Shadowbasic1.S_Panel:=True
                            else Shadowbasic1.S_Panel:=False;
  Repaint;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked=true then Shadowbasic1.S_Label:=True
                            else Shadowbasic1.S_Label:=False;
  Repaint;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  if CheckBox5.Checked=true then Shadowbasic1.S_Edit:=True
                            else Shadowbasic1.S_Edit:=False;
  Repaint;
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  if CheckBox6.Checked=true then Shadowbasic1.S_Other:=True
                            else Shadowbasic1.S_Other:=False;
  Repaint;
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  if CheckBox7.Checked=true then Shadowbasic1.S_Border:=True
                            else Shadowbasic1.S_Border:=False;
  Repaint;
end;

procedure TForm1.ColorBox1Change(Sender: TObject);
begin
  Shadowbasic1.ShadowColor:=ColorBox1.Selected;
  Repaint;
end;

procedure TForm1.ColorBox2Change(Sender: TObject);
begin
  Shadowbasic1.S_BorderColor:=ColorBox2.Selected;
  Repaint;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.Text='0' then Shadowbasic1.Direccion:=SLeftTop;
  if ComboBox1.Text='1' then Shadowbasic1.Direccion:=SLeftBotton;
  if ComboBox1.Text='2' then Shadowbasic1.Direccion:=SRightTop;
  if ComboBox1.Text='3' then Shadowbasic1.Direccion:=SRightBotton;
  Repaint;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
    CheckBox1.Checked:=True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  xa:=0;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Xa:=Xa+1;
  Caption:='El Paint se ha ejecutado ('+IntToStr(xa)+') veces';

end;

procedure TForm1.FormResize(Sender: TObject);
begin
   //Se aade esta linea para cuando minimizamos el Compo se restaure
   Shadowbasic1.Refresh;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  Shadowbasic1.Size:=SpinEdit1.Value;
  repaint;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  Shadowbasic1.SizeSD:=SpinEdit2.Value;
  Repaint;
end;



end.
